///////////////////////////////////////////////////////////////////////////////////
//Automatic defined prototypes
function player_1();
function fence();
function C_Smoke();


// A5 main wdl
////////////////////////////////////////////////////////////////////////////
// Files to over-ride:
// * logodark.bmp - the engine logo, include your game title
// * horizon.pcx - A horizon map displayed over the sky and cloud maps
////////////////////////////////////////////////////////////////////////////
// The PATH keyword gives directories where game files can be found,
// relative to the level directory
path "D:\\Program Files\\GStudio\\template";	// Path to WDL templates subdirectory

////////////////////////////////////////////////////////////////////////////
// The INCLUDE keyword can be used to include further WDL files,
// like those in the TEMPLATE subdirectory, with prefabricated actions
include <movement.c.wdl>;
include <messages.c.wdl>;
include <menu.c.wdl>;		// must be inserted before doors and weapons
include <particle.c.wdl>; // remove when you need no particles
include <doors.c.wdl>;		// remove when you need no doors
include <actors.c.wdl>;   // remove when you need no actors
include <weapons.c.wdl>;  // remove when you need no weapons
include <war.c.wdl>;      // remove when you need no fighting
//include <venture.wdl>;	// include when doing an adventure
include <lflare.c.wdl>;   // remove when you need no lens flares

////////////////////////////////////////////////////////////////////////////
// The engine starts in the resolution given by the follwing vars.
var video_mode = 8;	 
var video_depth = 32; 
var d3d_alphadepth = 32;
var d3d_shadowdepth = 32;

/////////////////////////////////////////////////////////////////
// Strings and filenames
// change this string to your own starting mission message.
string mission_str = "Fight your way through the level. Press [F1] for help";
string level_str = <test.WMB>; // give file names in angular brackets

/////////////////////////////////////////////////////////////////
// define a splash screen with the required A4/A5 logo
bmap splashmap = <logodark.pcx>; // the default logo in templates
panel splashscreen {
	bmap = splashmap;
	flags = refresh,d3d;
}

////////////////////////////////////////////////////////////////////////////
// The following script controls the sky
sky horizon_sky {
// A backdrop texture's horizontal size must be a power of 2;
// the vertical size does not matter
	type = <horizon.pcx>;
	tilt = -10;
	flags = scene,overlay,visible;
	layer = 3;
}

/////////////////////////////////////////////////////////////////
// The main() function is started at game start
function main()
{

var video_depth = 32; 
var d3d_alphadepth = 32;
var d3d_shadowdepth = 32;

fog_color = 1;
camera.fog = 45;

fog_color = 2;
camera.fog = 45;


fog_color = 3;
camera.fog = 45;

fog_color = 4;
camera.fog = 45;

// set some common flags and variables
//	warn_level = 2;	// announce bad texture sizes and bad wdl code
	tex_share = on;	// map entities share their textures

// center the splash screen for non-640x480 resolutions, and display it
	splashscreen.pos_x = (screen_size.x - bmap_width(splashmap))/2;
	splashscreen.pos_y = (screen_size.y - bmap_height(splashmap))/2;
	splashscreen.visible = on;
// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

// now load the level
	level_load(level_str);
// freeze the game
	freeze_mode = 1;

// wait the required second, then switch the splashscreen off.
	sleep(1);
  	splashscreen.visible = off;
	bmap_purge(splashmap);	// remove splashscreen from video memory

// load some global variables, like sound volume
	load_status();

// display the initial message
	msg_show(mission_str,10);

// initialize lens flares when edition supports flares
ifdef CAPS_FLARE;
	lensflare_start();
endif;

// use the new 3rd person camera
	

// un-freeze the game
	freeze_mode = 0;

//	client_move();	// for a possible multiplayer game
// call further functions here...
bg_color = 5;
person_3rd	= 2;
mouse_toggle();
}


/////////////////////////////////////////////////////////////////
// The following definitions are for the pro edition window composer
// to define the start and exit window of the application.
WINDOW WINSTART
{
	TITLE			"3D GameStudio";
	SIZE			480,320;
	MODE			IMAGE;	//STANDARD;
	BG_COLOR		RGB(240,240,240);
	FRAME			FTYP1,0,0,480,320;
//	BUTTON		BUTTON_START,SYS_DEFAULT,"Start",400,288,72,24;
	BUTTON		BUTTON_QUIT,SYS_DEFAULT,"Abort",400,288,72,24;
	TEXT_STDOUT	"Arial",RGB(0,0,0),10,10,460,280;
}

/* no exit window at all..
WINDOW WINEND
{
	TITLE			"Finished";
	SIZE			540,320;
	MODE	 		STANDARD;
	BG_COLOR		RGB(0,0,0);
	TEXT_STDOUT	"",RGB(255,40,40),10,20,520,270;

	SET FONT		"",RGB(0,255,255);
	TEXT			"Any key to exit",10,270;
}*/


/////////////////////////////////////////////////////////////////
//INCLUDE <debug.wdl>;

//vector variables for movement
var my_target[3]; //target vertor
var move_position[3]; //move vector

Function change_run() //The function to toggle run mode off and on
{
	if(player.skill10 == 0) // We check to see if the run mode is off
	{player.skill10 = 1;}   //If it is off we turn the run mode on
	else //if run mode is already turned on
	{
	player.skill10 = 0; //we turn the run mode off
	}
}

Function get_target() //get the target position on the level
{
mouse_to_level();
vec_set(my_target,target); //my_target becomes the same as target so we dont lose our vector
vec_set(move_position,target); //my_target becomes the same as target so we dont lose our vector
vec_sub(move_position,player.x); //we subtract the player position from the target position
vec_to_angle(player.pan,move_position); //set the players angle to the my_target position
player.tilt = 0; // Here we are making sure the player is not tilted, otherwise you player may be in a //weird position
if(key_shift == 1) //the shift key is pressed (1)
{
player.skill48 = 0; //set player mode to not moving
weapon_fire(); //attack with the current weapon
return; //leave the function
	}
player.skill48 = 1; //let the player entity know it has a target position
}

Function my_diablo_move() //main moving code
{
while(1) // always run this code
{
   		 if(player.skill48 == 1) //the player has a target to move to
   		 {
     			  while(vec_dist(player.x,my_target.x) > 35) //is the distance too great
     			 {
       			if(player.skill10 == 1) //if the player is in run mode
       			{
				force = my._force * 8; //Force is used by the template code to move the entity at that speed,
				//so we will multiply _force by 2.5 and assign that to force
				}
       			else //if the player is not in run mode
       			{
				force = my._force * 6;
				}
			if(mouse_right == 1){wait(1);player.skill48 = 0;break;}
			move_gravity();
			wait(1); //avoid a looping error
			}
		}
wait(1); //we always need to add a wait() command in a while loop to avoid an infinite loop error
}
}


Action player_1 //player action
{
player_walk_fight(); //call default code for fighting
my_diablo_move(); //call diablo style move code
}




	On_r  change_run; //when the R key is pressed it will run the above function and toggle the run mode
	On_mouse_left  get_target; //when the left mouse button is clicked call the get_target function
	


ACTION fence
{
my.oriented = on;
}

/////////////////////////////////*****
//////-----------
bmap rauch_map,<smoke2.bmp>;

// ************* GLOBAL VARIABLES ***************

var parray [1801]; // will be used as a 300*6 multi dimensional array
                   // each of the 300 entries will consist of: 0 = flag, 1 = x_pos, 2-5 = data slots
var ppoint = 0;    // points to the next free entry-slot, is set through searcharray()

var boom = 0; 	   // counter for explosion effects

// ************** SKILL USAGE ****************
// skill 7        size
// skill 8        rate / duration
// skill 10-12    pos
// skill 13       counter
// skill 14       points to the emitters array offset in parray[]

// *************** ARRAY FUNCTION **************

function sarray() {
	ppoint = 0;
	while (parray [ppoint*6] != 0) { ppoint += 1; }
}

// ************** SMOKE ****************

action C_Smoke
{
my.passable = on;
my.invisible = on;
	sarray();	 						// look for free array slot
	if (ppoint >= 300) {  }					// stop action if too many emitters already present
	my.skill14 = ppoint;						// set skill14 accordingly
	parray[my.skill14 * 6] = 1;					// set flag of the slot to occupied
	if (my.skill8 == 0) { my.skill8 = 4; }				// rate 0 defaults to 4
	if (my.skill7 == 0) { my.skill7 = 1; }				// size 0 defaults to 1
	if (my.skill7 < 0.2 && my.skill7 != -1) { my.skill7 = 0.2; }	// check size values and correct them
	if (my.skill7 > 3) { my.skill7 = 3; }
	while(1) {							// smokes forever
		if (my.skill7 > 0) {					// check if effect is turned ON
			my.skill13 -= 1;				// decrease emit counter
			if (my.skill13 <= 0) {
				my.skill13 = my.skill8 / time;					// set counter according to skill8

				parray[my.skill14 * 6 +2] = my.skill7;				// set size value in array
				parray[my.skill14 * 6 +1] = my.x + (random(4) - 2) * my.skill7;	// set pos.x value in array
				my.skill10 = my.skill14;					// array pointer stored in x_pos
				my.skill11 = my.y + (random(4) - 2) * my.skill7;		// set pos.y for emit
				my.skill12 = my.z;						// set pos.z for emit
				emit(1,my.skill10,smoke_particle);				// emit particle
    my.transparent = on; // Transparent Flare
			}
		}
		wait(1);
	}
}

function smoke_particle(){
	if(my_age == 0)	{
		my_alpha = 50;						// set to invisible at start
		my_color.blue = parray[my_pos.x * 6 + 1];		// get size from array
		my_speed.z = (0.7+random(1)) * my_color.blue;		// set speed.z
		my_color.red = random (50);				// set random values
		my_color.green = random (50);
		my_size = (1100+random(200)) * my_color.blue;		// set size
		my_map = rauch_map;
		my_flare = on;						// set transparency
		
	}
 	if (my_age > 80) {			// kill if too old
			MY_ACTION = null;
	}
	if (my_age > 17) {						// set alpha according to age
		my_alpha = 40 - my_age/2;
	} else { my_alpha = my_age * 2; }
	my_speed.x = (sin(my_age * 6 + my_color.red) / 2.5) * my_color.blue;	// movement
	my_speed.y = (cos(my_age * 7 + my_color.green) / 2) * my_color.blue;
}

///////////////////////////////////////**

bmap fire_parmap=<fireball.tga>;

function fire_effect();
function fire_property();


function fire_effect() {
	my.x+=random (15*(sin(total_ticks*200) * cos(total_ticks*50)));

	my.y+=random (15*(sin(total_ticks*200) * sin(total_ticks*50)));

	my.size=15;
	my.vel_x=0;
	my.vel_y=0;
	my.vel_z=2+random(2);
	my.move=on;
	my.bmap=fire_parmap;
	my.flare=on;
	my.bright=on;
	my.alpha=25;
	my.function=fire_property;
}

function fire_property() {
	my.alpha-=1*time;
	if (my.alpha<=0) {
		my.lifespan=0;
	}
}

action fire {
	While (1) {
		temp.x=my.x;
		temp.y=my.y;
		temp.z=my.z;
		effect(fire_effect,10*time,temp,temp);
		wait(1);
	}
}